<?php






function convertToFilename($filename) {

 global $FEATURE;

 $maxFilenameLength = 64;
 
 $allowedCharactersRegex = "/[^\w\,\.\-\(\)\[\]{}\$]/";
 $replacementCharacter = '_';

 if( $FEATURE['filename_forcetolower'] ) {
 $filename = strtolower($filename);
 }
 
 
 
 
 
 
 if ($FEATURE['UTF8']) {
 $filename = htmlentities($filename, ENT_QUOTES, 'UTF-8');
 }

 
 $filename = str_replace(
 array("&uuml;", "&auml;", "&ouml;", "&Uuml;", "&Auml;", "&Ouml;", "&szlig;"),
 array("ue" , "ae" , "oe" , "Ue" , "Ae" , "Oe" , "ss"),
 $filename
 );

 
 $filename = preg_replace('/&[^s]*;/i', "_", $filename);

 if ($FEATURE['UTF8']) {
 $filename = html_entity_decode($filename,ENT_COMPAT, 'UTF-8');
 }

 
 if ($FEATURE['UTF8']) {
 $filename = iconv("UTF-8", "CP1252", $filename);
 }
 $filename = preg_replace($allowedCharactersRegex, $replacementCharacter, $filename);
 if ($FEATURE['UTF8']) {
 $filename = iconv("CP1252", "UTF-8", $filename);
 }
 
 if (strlen($filename) > $maxFilenameLength) {

 $pathInfo = pathinfo($filename);

 if (isset($pathInfo['extension'])) {
 $extension = $pathInfo['extension'];
 }
 else {
 $extension = "";
 }

 
 
 if (!isset($pathInfo['filename'])){
 $pathInfo['filename'] = substr($pathInfo['basename'], 0, strpos($pathInfo['basename'], '.'));
 }

 $hasExtension = (strlen($extension) > 0 || substr($pathInfo['filename'], -1) == '.');
 $newFileNameLength = $maxFilenameLength - strlen($extension);

 if ($hasExtension) {
 $newFileNameLength--;
 }

 if ($newFileNameLength > 0) {
 $filename = substr($pathInfo['filename'], 0, $newFileNameLength);

 if ($hasExtension) {
 $filename .= '.' . $extension;
 }
 }

 if (strlen($filename) > $maxFilenameLength) {
 
 $filename = substr($filename, 0, $maxFilenameLength);
 }
 }

 return $filename;
}
